#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>
#include <sys/time.h>
#include <string.h>
#include <sys/stat.h>

#ifdef DOS
#include <pc.h>
#include <dos.h>
#endif
#ifdef LINUX
/*#include <sys/unistd.h>*/
#include <sys/types.h>
#include <linux/major.h>
#include <linux/kdev_t.h>
#include <signal.h>
#include <errno.h>
#include <termios.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#endif

unsigned int STAT_RAHMEN=8;
unsigned int STAT_POSCOL=7;
unsigned int STAT_SET=8;
unsigned int STAT_CHARBK=4*16+0;
unsigned int STAT_CHARFG=4*16+14;
unsigned int STAT_INS=3;
unsigned int STAT_SETH=7;
unsigned int STAT_PAGE=1;
unsigned int STAT_PAGEH=9;

    
int highascii[15][10]={
218,191,192,217,196,179,195,180,193,194,
201,187,200,188,205,186,204,185,202,203,
213,184,212,190,30,32,30,32,207,209,
214,183,211,189,196,186,199,182,208,210,
197,206,216,215,232,233,155,156,153,239,
176,177,178,219,223,220,221,222,254,250,
1,2,3,4,5,6,240,127,14,15,
24,25,30,31,16,17,18,29,20,21,
174,175,242,243,169,170,253,246,171,172,
227,241,244,245,234,157,228,248,251,252,
224,225,226,229,230,231,235,236,237,238,
128,135,165,164,152,159,247,249,173,168,
131,132,133,160,166,134,142,143,145,146,
136,137,138,130,144,140,139,141,161,158,
147,148,149,162,167,150,129,151,163,154
};

void update_ansi();
void ende();
void insert_colm();
void curctrl();
void delete_colm();
void insert_line();
void delete_line();
void update_line();
void insert_char();
void delete_char();
void show_statusbar();
void resize();
void initnew();
void syncronize();

struct termios save_termios;

struct {
    int fd;
    int servermode;
    int connected;
    int xpos;
    int ypos;
    int insert;
}netz;


struct scren{
    char lines;
    char cols;
};
struct scren scrn;

struct bil{
    unsigned char *data_char;
    char *data_col;
    int screenheight;
    int xpos;
    int ypos;
    int fstline;
    int lastline;
    int inited;
};
struct bil bild[99];

int scx=0;   /* the cursor position on the screen */
int scy=0;
int actcol=7; /* color at the moment */
int curpg=0,oldcurpg=0; /* current page */
int set=5;   /* char set */
int drawcol=3; /* draw color */
int insert=0; /* INS-key status */
char pathname[255];
int displines; /* how much lines you can see */
int ystart; /* where the ansi display starts */
int servermode=0;


#ifdef LINUX
#include "inc_lin.c"
#endif
#ifdef DOS
#include "inc_dos.c"
#endif

/* background graphics */
#include "_a_color.h"
#include "_a_load.h"
#include "_a_conf.h"
#include "_a_net.h"
#include "_a_title.h"
#include "config.h"


#include "screen.c"
#include "mem.c"
#include "load.c"
#include "save.c"
#include "loadgui.c"

/* functions */
#include "alta.c"
#include "config.c"
#include "mod.c"
#include "server.c"
#include "client.c"
#include "block.c"
#include "page.c"
    
void ende_error(){
    cls();
    endoszeug();
    close(netz.fd);
    system("reset");
    printf("pathname:%s\n",pathname);
    perror(":");
    exit(1);
}
        
void ende(){
    cls();
    close(netz.fd);
    system("reset");
    endoszeug();
    
    printf("\n>> bmdraw v0.22  //  code: pandur & sarlac  //  style: ave shine mother zippy\n");
    printf(">> check www.drastic.net for updates\n\n");
/*    printf("pathname:%s\n",pathname);
    perror(":");*/
    exit(0);
}



void unflash_net_cursor(){
}

void flash_net_cursor(int a,int jane){
    int ch,co,nx,ny,donotset=1;
        
    ch=bild[curpg].data_char[netz.xpos+(netz.ypos)*scrn.cols];
    co=bild[curpg].data_col[netz.xpos+(netz.ypos)*scrn.cols];

    if(netz.ypos>bild[curpg].fstline){
        if(netz.ypos<bild[curpg].fstline+scrn.lines){
            donotset=0;
            ny=netz.ypos-bild[curpg].fstline;
            nx=netz.xpos;
            if(status.line==1)ny=ny+status.size;
            if(status.line==2){
                if(ny>=scrn.lines-status.size)donotset=1;
            }
        }
    }
    
    if(donotset==0){
        if(jane==1)setcol(co^a);
        else setcol(co);
        cmove(ny,nx);
        myprintc(ch);
        setcol(actcol);
    }
}


void flash_cursor(int a,int jane){
    int ch,co;
        
    ch=bild[curpg].data_char[bild[curpg].xpos+(bild[curpg].ypos+bild[curpg].fstline)*scrn.cols];
    co=bild[curpg].data_col[bild[curpg].xpos+(bild[curpg].ypos+bild[curpg].fstline)*scrn.cols];

    if(jane==1)setcol(co^a);
    else setcol(co);
    cmove(scy,scx);
    curmove(scy,scx);
    myprintc(ch);
    setcol(actcol);
}

/*void unflash_cursor(){
    int ch,co;
        
    ch=bild[curpg].data_char[bild[curpg].xpos+(bild[curpg].ypos+bild[curpg].fstline)*scrn.cols];
    co=bild[curpg].data_col[bild[curpg].xpos+(bild[curpg].ypos+bild[curpg].fstline)*scrn.cols];

    setcol(co);
    cmove(scy,scx);
    myprintc(ch);
    setcol(actcol);
} */

void edit(){
    int q,f,c;
    char temp1;
    char buf[5];
    int r=0,ni=0;

    while((c=ggetch(1,1))!=24)
    {
        switch(c){
        /**** CURSOR KEYS ***************************************/
        case K_TAB:
            tab();
            curctrl();
            break;
        case K_HOME:
            bild[curpg].xpos=0;
            status_posi(statusline());
            curctrl();
            break;
        case K_END:
            bild[curpg].xpos=79;
            status_posi(statusline());
            curctrl();
            break;
        case K_LEFT:
            bild[curpg].xpos--;
            curctrl();
            break;
        case K_RIGHT:
            bild[curpg].xpos++;
            curctrl();
            break;
        case K_UP:
            bild[curpg].ypos--;
            curctrl();
            break;
        case K_DOWN:
            bild[curpg].ypos++;
            curctrl();
            break;
        case K_PGDN:
            bild[curpg].fstline=bild[curpg].fstline+scrn.lines-2;
            update_ansi();
            curctrl();
            break;
        case K_PGUP:
            bild[curpg].fstline=bild[curpg].fstline-scrn.lines-2;
            update_ansi();
            curctrl();
            break;
        case K_F1:
            c=highascii[set][0];
            setchar(c);
            curctrl();
            break;
        case K_F2:
            c=highascii[set][1];
            setchar(c);
            curctrl();
            break;
        case K_F3:
            c=highascii[set][2];
            setchar(c);
            curctrl();
            break;
        case K_F4:
            c=highascii[set][3];
            setchar(c);
            curctrl();
            break;
        case K_F5:
            c=highascii[set][4];
            setchar(c);
            curctrl();
            break;
        case K_F6:
            c=highascii[set][5];
            setchar(c);
            curctrl();
            break;
        case K_F7:
            c=highascii[set][6];
            setchar(c);
            curctrl();
            break;
        case K_F8:
            c=highascii[set][7];
            setchar(c);
            curctrl();
            break;
        case K_F9:
            c=highascii[set][8];
            setchar(c);
            curctrl();
            break;
        case K_F10:
            c=highascii[set][9];
            setchar(c);
            curctrl();
            break;

        /**** CHANGE CHARSET *****************************************/
        case K_ALT_F1:
            status_charset(statusline(),0);
            break;
        case K_ALT_F2:
            status_charset(statusline(),1);
            break;
        case K_ALT_F3:
            status_charset(statusline(),2);
            break;
        case K_ALT_F4:
            status_charset(statusline(),3);
            break;
        case K_ALT_F5:
            status_charset(statusline(),4);
            break;
        case K_ALT_F6:
            status_charset(statusline(),5);
            break;
        case K_ALT_F7:
            status_charset(statusline(),6);
            break;
        case K_ALT_F8:
            status_charset(statusline(),7);
            break;
        case K_ALT_F9:
            status_charset(statusline(),8);
            break;
        case K_ALT_F10:
            status_charset(statusline(),9);
            break;
        case K_ALT_F11:
            status_charset(statusline(),10);
            break;
        case K_ALT_F12:
            status_charset(statusline(),11);
        break;
        /**** BLOCK MODE ****************************************/
        case K_ALT_C:
            initnew();
            update_ansi();
            show_statusbar();
            ni=0;
            if(netz.connected==1){
                buf[0]='n';
                buf[1]=0;
                buf[2]=0;
                buf[3]=0;
                buf[4]=0;
                while(ni<5){
                    r=write(netz.fd,buf,5);
                    if(r>0){
                        ni+=r;
                    }
                }
            }
            break;
        /**** BLOCK MODE ****************************************/
        case K_ALT_B:
            blockmode();
            update_ansi();
            show_statusbar();
            break;
        /**** INSERT / DELETE ROW *******************************/
        case K_ALT_Q:
            delete_colm(bild[curpg].xpos,0);
            update_ansi();
            break;
        case K_ALT_W:
            insert_colm(bild[curpg].xpos,0);
            update_ansi();
            break;
        /**** DELETE LINE ***************************************/
        case K_ALT_Y:
            delete_line(bild[curpg].ypos,0);
            update_ansi();
            break;
        /**** INSERT LINE ***************************************/
        case K_ALT_I:
            insert_line(bild[curpg].ypos,0);
            update_ansi();
            break;
        /**** MULTIPAINTER MODE ***************************************/
        case K_ALT_M:
            multipaint();
            break;
        /**** EXIT **********************************************/
        case K_ALT_X:
            ende();
            break;
        /**** COLOR SELECTOR ************************************/
        case K_ALT_A:
            drawcol=col_sel();
            status_color(statusline());
            curctrl();
            break;
        /**** COLOR PICKUP (ALT+U) ******************************/
        case K_ALT_U :
            drawcol=bild[curpg].data_col[(bild[curpg].ypos+bild[curpg].fstline)*80+bild[curpg].xpos];
            show_statusbar();
            break;
        /*** LOAD ANSI ******************************************/
        case K_ALT_L:
            cls();
            showansi(a_load,3995);
            loadlight();
            cls();
            if(bild[curpg].lastline<50)bild[curpg].lastline=50;
            resize();
            ni=0;
            if(netz.connected==1){
                buf[0]='y';
                buf[1]=bild[curpg].lastline;
                buf[2]=0;
                buf[3]=0;
                buf[4]=0;
                while(ni<5){
                    r=write(netz.fd,buf,5);
                    if(r>0){
                        ni+=r;
                    }
                }
                syncronize(bild[curpg].lastline,0);
            }
            show_statusbar();
            update_ansi();
            curctrl();
            break;
        /*** PAGE MANAGEMENT ************************************/
        case K_ALT_E:
            curpg=selectpage();
            curpgctrl();
            show_statusbar();
            break;
        /*** SAVE ANSI ******************************************/
        case K_ALT_S:
            save_ansi();
            update_ansi();
            break;
        /*** OPTIONS *****************************************/
        case K_ALT_O:
            cls();
            showansi(a_config,4000);
            konfig();
            cls();
            show_statusbar();
            update_ansi();
            curctrl();
            break;
        /*** INSERT MODE **************************************/
        case K_INSERT:
            ni=0;
            if(insert==0)insert=1;
            else insert=0;

            status_ins(statusline());
            curctrl();
            if(netz.connected==1){
                buf[0]='i';
                buf[1]=insert;
                buf[2]=0;
                buf[3]=0;
                buf[4]=0;
                while(ni<5){
                    r=write(netz.fd,buf,5);
                    if(r>0){
                        ni+=r;
                    }
                }
            }
            break;
        /*** BACKSPACE ******************************************/
        case K_BACKSPACE:
            ni=0;
            bild[curpg].xpos--;
            curctrl();
            delete_char(0);
            update_line(bild[curpg].ypos,0);
            curctrl();
            
            if(netz.connected==1){
                buf[0]='b';
                buf[1]=bild[curpg].xpos;
                buf[2]=bild[curpg].ypos+bild[curpg].fstline;
                buf[3]=32;
                buf[4]=drawcol;
                while(ni<5){
                    r=write(netz.fd,buf,5);
                    if(r>0){
                        ni+=r;
                    }
                }
            }
            
            break;
        /*** ENTF / DELETE CHAR *********************************/
        case K_DC:
            delete_char(0);
            curctrl();
            break;
        /*** ENTER **********************************************/
        case 13:
            bild[curpg].xpos=0;
            bild[curpg].ypos++;
            if(bild[curpg].ypos+bild[curpg].fstline>bild[curpg].lastline){
                bild[curpg].lastline++;
                resize();
                update_ansi();
            }
            curctrl();
            break;
        case 27:
            quickcolor();
            break;
        /*** DEFAULT *******************************************/
        default:
            setchar(c);
            curctrl();
            break;
        }
    }
}

void welcome(){
    int c;
    cls();
    showansi(a_title,3999);
    setcol(8);
    myprintpos(14,0,">> bmdraw v0.22");
    while((c=ggetch(0,0))!=13&&c!=27&&c!=32)
    {
    }
}

int main(int argc, char **argv)
{
    netz.connected=0;
    netz.ypos=0;
    netz.xpos=0;
    netz.connected=0;
#ifdef LINUX
    signal(SIGINT,ende);
    signal(SIGSEGV,ende_error);
#endif
    init_oszeug();
    welcome();
    getcwd(pathname,255);
    status.line=1;
    status.size=1;
    netz.insert=0;
    loadconfig();
    initnew();
    show_statusbar();
    update_ansi();
    curctrl();
    edit();
    ende();
}

